; ------------------------------------------------------------------------------
;	BGM Driver mixer
; ==============================================================================
;	2009/12/28	t.hara
; ------------------------------------------------------------------------------

		.include	"msx.asm"
		.include	"bgmdrv_chinfo.asm"
		.include	"bgmdrv_music_h.asm"
		.include	"bgmdrv_envelope_h.asm"
		.include	"bgmdrv_vibrato_h.asm"

		.globl		bgmdrv_music_data_top

		.area	CODE (ABS)

; ------------------------------------------------------------------------------
;	1/60bԊuŌĂяo
;	input:
;		Ȃ
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		P`l
; ------------------------------------------------------------------------------
bgmdrv_interrupt_handler::
		; `lȌ
		ld		ix, #bgmdrv_chinfo0
		call	bgmdrv_music_single				; ȃf[^̉͏
		call	bgmdrv_envelope_main			; Gx[v̏
		call	bgmdrv_vibrato_main				; ru[g̏
		; `lP̏
		ld		ix, #bgmdrv_chinfo1
		call	bgmdrv_music_single				; ȃf[^̉͏
		call	bgmdrv_envelope_main			; Gx[v̏
		call	bgmdrv_vibrato_main				; ru[g̏
		; `lQ̏
		ld		ix, #bgmdrv_chinfo2
		call	bgmdrv_music_single				; ȃf[^̉͏
		call	bgmdrv_envelope_main			; Gx[v̏
		call	bgmdrv_vibrato_main				; ru[g̏
		; ʉ̏
		; 
		; ~LT[
		call	mixer_main
		ret

; ------------------------------------------------------------------------------
;	ĐJn
;	input:
;		a	...	Ȕԍ
;	output:
;		CtO: ǔԍꍇ 1, ɍĐJnꍇ 0
;	break:
;		ׂ
;	comment:
;		
; ------------------------------------------------------------------------------
bgmdrv_music_play::
		; ݂ȐƔr
		ld		hl, #bgmdrv_music_data_top
		cp		(hl)
		ccf
		ret		c
		; AhXɕϊ
		inc		hl
		rlca
		ld		c, a
		ld		b, #0
		add		hl, bc							; HL=ȃf[^̃AhXi[ĂAhX
		ld		e, (hl)
		inc		hl
		ld		d, (hl)
		push	de
		pop		iy								; IY=ȃf[^̃AhX
		; ւɂđS`lɑ΂ď
		di
		ld		ix, #bgmdrv_chinfo0
		ld		l, 0(iy)						; HL=`lÕf[^AhX
		ld		h, 1(iy)
		call	bgmdrv_music_play_single
		ld		ix, #bgmdrv_chinfo1
		ld		l, 2(iy)						; HL=`lP̃f[^AhX
		ld		h, 3(iy)
		call	bgmdrv_music_play_single
		ld		ix, #bgmdrv_chinfo2
		ld		l, 4(iy)						; HL=`lQ̃f[^AhX
		ld		h, 5(iy)
		call	bgmdrv_music_play_single
		ei
		or		a								; CtO=0
		ret

; ------------------------------------------------------------------------------
;	Đ~
;	input:
;		Ȃ
;	output:
;		Ȃ
;	break:
;		b, c, d, e, f, h, l
;	comment:
;		P`lB֏ԂŌĂԂƁB
; ------------------------------------------------------------------------------
bgmdrv_music_stop::
		di
		ld		ix, #bgmdrv_chinfo0
		call	bgmdrv_music_stop_single
		ld		ix, #bgmdrv_chinfo1
		call	bgmdrv_music_stop_single
		ld		ix, #bgmdrv_chinfo2
		call	bgmdrv_music_stop_single
		ei
		ret

; ------------------------------------------------------------------------------
;	~LT[
;	input:
;		Ȃ
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		P`lB֏ԂŌĂԂƁB
; ------------------------------------------------------------------------------
mixer_main::
		; PSGAhXb`
		ld		a, #0
		out		(PSG_ADR), a
		; gݒ
		ld		ix, #bgmdrv_chinfo0
		call	mixer_out_freq
		ld		ix, #bgmdrv_chinfo1
		call	mixer_out_freq
		ld		a, (sound_effect_enable)
		or		a
		jp		nz, mixer_sound_effect_on
		ld		ix, #bgmdrv_chinfo2
		call	mixer_out_freq
		jp		mixer_sound_effect_off
mixer_sound_effect_on:
		call	mixer_sound_effect_out_freq
mixer_sound_effect_off:
		; mCYg
		ld		a, (noise_freq)
		out		(PSG_WR), a
		; Cl[u
		call	mixer_enabler
		ret

; ------------------------------------------------------------------------------
;	
;	input:
;		ix	...	`l̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		P`lB֏ԂŌĂԂƁB
; ------------------------------------------------------------------------------
mixer_out_freq:
		; 擾
		ld		l, CH_TONE_BASE_L(ix)
		ld		h, CH_TONE_BASE_H(ix)
		; ru[gɂgItZbgZ
		ld		c, CH_WAVE_OFFSET(ix)
		ld		b, #0
		bit		7, c									; mF
		jp		z, mixer_out_freq_skip1
		dec		b										; g
mixer_out_freq_skip1:
		add		hl, bc
		; g[ωg`ɂgItZbgZ
		ld		c, CH_TONE_OFFSET(ix)
		ld		b, #0
		bit		7, c									; mF
		jp		z, mixer_out_freq_skip2
		dec		b										; g
mixer_out_freq_skip2:
		add		hl, bc
		; sb`x_ɂgItZbgZ
		ld		c, CH_PITCH_OFFSET(ix)
		ld		b, #0
		bit		7, c									; mF
		jp		z, mixer_out_freq_skip3
		dec		b										; g
mixer_out_freq_skip3:
		add		hl, bc
		; PSG֏o͂
		ld		c, #PSG_WR
		out		(c), l
		out		(c), h
		ret

; ------------------------------------------------------------------------------
;	ʉp
;	input:
;		Ȃ
;	output:
;		Ȃ
;	break:
;		
;	comment:
;		֏ԂŌĂԂƁB
; ------------------------------------------------------------------------------
mixer_sound_effect_out_freq:
		; 
		ret

; ------------------------------------------------------------------------------
;	Cl[u̐ݒ
;	input:
;		Ȃ
;	output:
;		Ȃ
;	break:
;		
;	comment:
;		֏ԂŌĂԂƁB
; ------------------------------------------------------------------------------
mixer_enabler:
		xor		a
		ld		ix, #bgmdrv_chinfo2
		call	mixer_enabler_single
		rlca
		ld		ix, #bgmdrv_chinfo1
		call	mixer_enabler_single
		rlca
		ld		ix, #bgmdrv_chinfo0
		call	mixer_enabler_single
		xor		#(0x80 + 0x3F)
		out		(PSG_WR), a
		ret

; ------------------------------------------------------------------------------
;	Cl[u̐ݒ
;	input:
;		ix	...	`l̃AhX
;	output:
;		Ȃ
;	break:
;		
;	comment:
;		֏ԂŌĂԂƁB
; ------------------------------------------------------------------------------
mixer_enabler_single:
		ld		l, CH_INST_L(ix)
		ld		h, CH_INST_H(ix)
		push	hl
		pop		iy
		or		INST_MIX(iy)
		ret

; ==============================================================================
;	[NGA
; ==============================================================================

; ------------------------------------------------------------------------------
;	ȃf[^
; ------------------------------------------------------------------------------
bgmdrv_chinfo0:
		.ds		CH_INFO_SIZE
bgmdrv_chinfo1:
		.ds		CH_INFO_SIZE
bgmdrv_chinfo2:
		.ds		CH_INFO_SIZE
noise_freq::
		.db		#0					; mCY
sound_effect_enable::
		.db		#0					; ʉĐۂ 1: Đ, 0: ~
