; ------------------------------------------------------------------------------
;	program loader
; ==============================================================================
;	2009/12/13	t.hara
; ------------------------------------------------------------------------------

		.area		CODE (ABS)
		.org		#0x9000 - 7

		.include	"bgmdrv_main_size.asm"
		.include	"msx.asm"

PROGRAM_TOP		= 0x4000
PROGRAM_END		= BGMDRV_CODE_SIZE

; ------------------------------------------------------------------------------
;	BSAVE header
; ------------------------------------------------------------------------------
bsave_header::
		.db		#0xFE
		.dw		#0x9000
		.dw		#program_data + (PROGRAM_END - PROGRAM_TOP)
		.dw		#0x9000

; ------------------------------------------------------------------------------
;	program_data ȍ~ɂvO 4000h` ֓]vO
; ------------------------------------------------------------------------------
program_loader::
		; page1 ̃Xbg RAM ɐ؂ւ
		ld		a, (RAMAD1)
		ld		h, #0x40			; page1
		call	ENASLT				; ւŕԂĂ
		; ]
		ld		hl, #program_data
		ld		de, #PROGRAM_TOP
		ld		bc, #PROGRAM_END - PROGRAM_TOP
		ldir
		; page1 ̃Xbg ROM ɖ߂
		ld		a, (EXPTBL)
		ld		h, #0x40			; page1
		call	ENASLT				; ւŕԂĂ
		; page1 ̑ɁuCALLߊgv𗧂Ă
		ld		hl, #SLTATR + 1		; page1 Ȃ̂ +1 Ă
		ld		a, (RAMAD1)			; page1  DRAMXbgԍ  &Be000nnmm ... e: g̗L(1:g), nn: gXbgԍ, mm: {Xbgԍ
		ld		b, a
		and		#0x0C				; DRAM ̊gXbgԍ * 4 𓾂
		ld		c, a
		ld		a, b
		ld		b, #0
		and		#0x03				; DRAM ̊{Xbgԍ𓾂
		rlca
		rlca
		rlca
		rlca
		or		c
		ld		c, a
		add		hl, bc				; DRAM page1  SLTADR
		ld		a, #0x20			; CALLߊg ̑
		ld		(hl), a
		ei
		ret

; ------------------------------------------------------------------------------
;	ȍ~ bgmdrv_main.bin ̃oCi
; ------------------------------------------------------------------------------
program_data::
