; ------------------------------------------------------------------------------
;	MSX BIOS/BDOS/Hardware information
; ==============================================================================
;	2009/12/13	t.hara
; ------------------------------------------------------------------------------

; -----------------------------------------------------------------------------
;	BIOS entry
; -----------------------------------------------------------------------------
CALSLT							= 0x001C
ENASLT							= 0x0024
WRTVRM							= 0x004D
SETWRT							= 0x0053
FILVRM							= 0x0056
LDIRVM							= 0x005C
CHGMOD							= 0x005F
BREAKX							= 0x00B7
BEEP							= 0x00C0
GTSTCK							= 0x00D5
GTTRIG							= 0x00D8
KILBUF							= 0x0156
CALBAS							= 0x0159

; -----------------------------------------------------------------------------
;	BASIC interpreter
; -----------------------------------------------------------------------------
BASERR							= 0x406F		; BASICG[ (I)E=G[ԍ, HL=݂̃eLXgAhX ߂ĂȂ
FRMEVL							= 0x4C64		; Cӎ] (I)HL=擪 (O)VALTYP=^, DAC=
GETBYT							= 0x521C		; 1byte] (I)HL=擪 (O)HL=AhX, A/E=
FRMQNT							= 0x542F		; 2byte] (I)HL=擪 (O)HL=AhX, DE=
FRESTR							= 0x67D0		; o^ (I)VALTYP(), DAC (O)HL=XgOfXNv^
PTRGET							= 0x5EA4		; ϐAhX擾 (I)HL=ϐAhX, SUBFLG (O)HL=AhX, DE=ϐAhX

VALTYP							= 0xF663
DAC								= 0xF7F6
SUBFLG							= 0xF6A5		; 0=Pϐ, 0ȊO=zϐ

; -----------------------------------------------------------------------------
;	BIOS workarea
; -----------------------------------------------------------------------------
RAMAD0							= 0xF341		; page0  RAMXbgԍ (DiskBIOS work)
RAMAD1							= 0xF342		; page1  RAMXbgԍ (DiskBIOS work)
RAMAD2							= 0xF343		; page2  RAMXbgԍ (DiskBIOS work)
RAMAD3							= 0xF344		; page3  RAMXbgԍ (DiskBIOS work)
CLIKSW							= 0xF3DB		; L[NbNXCb` 0=OFF, 0ȊO=ON
RG1SAV							= 0xF3E0
STATFL							= 0xF3E7
FORCLR							= 0xF3E9
BAKCLR							= 0xF3EA
BDRCLR							= 0xF3EB
EXPTBL							= 0xFCC1		; MAIN-ROM  Xbgԍ
PROCNM							= 0xFD89		; CALL߂̊gXe[ggi[[N(16byte)
SLTATR							= 0xFCC9		; eXbg̑

; -----------------------------------------------------------------------------
;	BIOS hook
; -----------------------------------------------------------------------------
H_TIMI							= 0xFD9F		; VSYNC荞݃tbN
DISINT							= 0xFFCF		; DOSgp
ENAINT							= 0xFFD4		; DOSgp

; -----------------------------------------------------------------------------
;	I/O port
; -----------------------------------------------------------------------------
VDP_VRAM_IO						= 0x98
VDP_CMDREG_IO					= 0x99
VDP_PALREG_IO					= 0x9A
VDP_REG_IO						= 0x9B

PSG_ADR							= 0xA0
PSG_WR							= 0xA1
PSG_RD							= 0xA2
