; ------------------------------------------------------------------------------
;	BGM Driver software envelope
; ==============================================================================
;	2009/12/28	t.hara
; ------------------------------------------------------------------------------

		.include	"msx.asm"
		.include	"bgmdrv_chinfo.asm"

		.area	CODE (ABS)

; ------------------------------------------------------------------------------
;	P`l̃Gx[v
;	input:
;		ix	...	`l̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		P`l̃Gx[vg`Z̒
; ------------------------------------------------------------------------------
bgmdrv_envelope_main::
		; IY ɉFf[^̃AhX
		ld		l, CH_INST_L(ix)
		ld		h, CH_INST_H(ix)
		push	hl
		pop		iy
		; Ԃɉďς
		ld		a, CH_ENV_STATE(ix)
		cp		#CH_ENV_STATE_AR
		ret		c
		jp		z, bgmdrv_attack_rate
		cp		#CH_ENV_STATE_SR
		jp		c, bgmdrv_decay_rate
		jp		z, bgmdrv_sustain_rate
		jp		bgmdrv_release_rate

		; A^bNCg̏
bgmdrv_attack_rate:
		ld		a, CH_ENV_VOL(ix)
		add		a, INST_AR(iy)
		jp		c, bgmdrv_attack_rate_next
		ld		CH_ENV_VOL(ix), a						; A^bNCgZʂVʂƂ
		ret
		; A^bNCg̏Ԃ甲
bgmdrv_attack_rate_next:
		ld		CH_ENV_VOL(ix), #255					; U肫ꂽ̂ōőɃNbv
		ld		CH_ENV_STATE(ix), #CH_ENV_STATE_DR		; fBPCCg֑J
		ret

		; fBPCCg̏
bgmdrv_decay_rate:
		ld		a, CH_ENV_VOL(ix)
		sub		a, INST_DR(iy)
		cp		INST_SL(iy)								; TXeBxɓBH
		jp		c, bgmdrv_decay_rate_next
		ld		CH_ENV_VOL(ix), a						; fBPCCgZʂVʂƂ
		ret
		; fBPCCg̏Ԃ甲
bgmdrv_decay_rate_next:
		ld		a, INST_SL(iy)
		ld		CH_ENV_VOL(ix), a						; U肫ꂽ̂ōőɃNbv
		ld		CH_ENV_STATE(ix), #CH_ENV_STATE_SR		; TXeBCg֑J
		ret

		; TXeBCg̏
bgmdrv_sustain_rate:
		ld		a, CH_ENV_VOL(ix)
		sub		a, INST_SR(iy)
		jp		c, bgmdrv_sustain_rate_next
		ld		CH_ENV_VOL(ix), a						; TXeBCgZʂVʂƂ
		ret
		; fBPCCg̏Ԃ甲
bgmdrv_sustain_rate_next:
		ld		CH_ENV_VOL(ix), #0						; 
		ld		CH_ENV_STATE(ix), #CH_ENV_STATE_IN		; ~Ԃ֑J
		ret

		; [XCg̏
bgmdrv_release_rate:
		ld		a, CH_ENV_VOL(ix)
		sub		a, INST_RR(iy)
		jp		c, bgmdrv_release_rate_next
		ld		CH_ENV_VOL(ix), a						; [XCgZʂVʂƂ
		ret
		; fBPCCg̏Ԃ甲
bgmdrv_release_rate_next:
		ld		CH_ENV_VOL(ix), #0						; 
		ld		CH_ENV_STATE(ix), #CH_ENV_STATE_IN		; ~Ԃ֑J
		ret

; ------------------------------------------------------------------------------
;	P`l̃Gx[v KeyOn
;	input:
;		ix	...	`l̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		KeyOnɔȂAGx[vԂʒu֖߂
; ------------------------------------------------------------------------------
bgmdrv_envelope_keyon::
		xor		a
		ld		CH_ENV_STATE(ix), a
		ld		CH_ENV_VOL(ix), a
		ret

; ------------------------------------------------------------------------------
;	P`l̃Gx[v KeyOff
;	input:
;		ix	...	`l̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		KeyOffɔȂAGx[vԂ[XCgֈڂ
; ------------------------------------------------------------------------------
bgmdrv_envelope_keyoff::
		ld		a, CH_ENV_STATE(ix)
		or		a
		ret		z										; ~ԂȂ牽Ȃ
		ld		CH_ENV_STATE(ix), #CH_ENV_STATE_RR		; IɃ[XCg֑J
		ret

; ------------------------------------------------------------------------------
;	P`l̃Gx[v KeyOff`FbN
;	input:
;		ix	...	`l̃AhX
;	output:
;		ztO	...	KeyOffȂ 1, KeyOnȂ 0
;	break:
;		a, f
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
bgmdrv_envelope_check_keyoff::
		ld		a, CH_ENV_STATE(ix)
		cp		#CH_ENV_STATE_RR
		ret		z
		cp		#CH_ENV_STATE_IN
		ret

; ------------------------------------------------------------------------------
;	P`l̃Gx[v~
;	input:
;		ix	...	`l̃AhX
;	output:
;		Ȃ
;	break:
;		a, f
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
bgmdrv_envelope_force_stop::
		xor		a
		ld		CH_ENV_STATE(ix), a						; ~Ԃɂ
		ld		CH_ENV_VOL(ix), a						; ʂ 0 ɂ
		ret
